#include<bits/stdc++.h>
using namespace std;

//priority_queue<int> s,f;
int br[10000003];

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,maxot=0,dylmx=0,curr=0;
    cin>>n;
    for(int i=0;i<n;i++){
        int s1,f1;
        cin>>s1>>f1;
        br[s1]++;
        br[f1]--;
    }
    //sort(s,s+n);
    //sort(f,f+n);
    for(int i=1;i<10000000;i++){
        curr+=br[i];
        if(curr>maxot){
            maxot=curr;
            dylmx=1;
        }else if(curr==maxot){
            dylmx++;
        }
    }
    cout<<maxot<<endl<<dylmx;

    return 0;
}
